# SwaggerClient-php
TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2020-05-31T17:48:12Z
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen
For more information, please visit [tollguru.com](tollguru.com)

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new Swagger\Client\Api\GPSTracestracksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$body = new \Swagger\Client\Model\Body1(); // \Swagger\Client\Model\Body1 | 

try {
    $result = $apiInstance->routeDownloadPost($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling GPSTracestracksApi->routeDownloadPost: ', $e->getMessage(), PHP_EOL;
}

$apiInstance = new Swagger\Client\Api\GPSTracestracksApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$vehicle_type = "vehicle_type_example"; // string | 
$body = new \Swagger\Client\Model\Object(); // Object | 
$vehicle_name = "vehicle_name_example"; // string | Specify name for your vehicle to identify the response json for particular vehicle
$height = "height_example"; // string | Specify the vehicle height to get accurate tolls for toll roads where tolls depend on axles and vehicle height
$weight = "weight_example"; // string | Specify the vehicle weight to get accurate tolls for toll roads where tolls depend on axles and vehicle weight
$is_async = false; // bool | The API will function in asynchronous mode is set to true

try {
    $result = $apiInstance->routeUploadPost($vehicle_type, $body, $vehicle_name, $height, $weight, $is_async);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling GPSTracestracksApi->routeUploadPost: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://dev.tollguru.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*GPSTracestracksApi* | [**routeDownloadPost**](docs/Api/GPSTracestracksApi.md#routedownloadpost) | **POST** /route/download | Download Async Results
*GPSTracestracksApi* | [**routeUploadPost**](docs/Api/GPSTracestracksApi.md#routeuploadpost) | **POST** /route/upload | Request
*OriginAndDestinationPairApi* | [**gmapsPost**](docs/Api/OriginAndDestinationPairApi.md#gmapspost) | **POST** /gmaps | Google Maps Routes
*OriginAndDestinationPairApi* | [**herePost**](docs/Api/OriginAndDestinationPairApi.md#herepost) | **POST** /here | HERE Maps Routes
*RoutePolylineApi* | [**routePost**](docs/Api/RoutePolylineApi.md#routepost) | **POST** /route | Route polyline (from HERE/ Google map)

## Documentation For Models

 - [Address](docs/Model/Address.md)
 - [AllOfGmapRequestBodyDriver](docs/Model/AllOfGmapRequestBodyDriver.md)
 - [AllOfGmapRequestBodyFrom](docs/Model/AllOfGmapRequestBodyFrom.md)
 - [AllOfGmapRequestBodyFuelEfficiency](docs/Model/AllOfGmapRequestBodyFuelEfficiency.md)
 - [AllOfGmapRequestBodyHos](docs/Model/AllOfGmapRequestBodyHos.md)
 - [AllOfGmapRequestBodyTo](docs/Model/AllOfGmapRequestBodyTo.md)
 - [AllOfGmapRequestBodyVehicleType](docs/Model/AllOfGmapRequestBodyVehicleType.md)
 - [AllOfHereRequestBodyDriver](docs/Model/AllOfHereRequestBodyDriver.md)
 - [AllOfHereRequestBodyFrom](docs/Model/AllOfHereRequestBodyFrom.md)
 - [AllOfHereRequestBodyFuelEfficiency](docs/Model/AllOfHereRequestBodyFuelEfficiency.md)
 - [AllOfHereRequestBodyHos](docs/Model/AllOfHereRequestBodyHos.md)
 - [AllOfHereRequestBodyTo](docs/Model/AllOfHereRequestBodyTo.md)
 - [AllOfHereRequestBodyTruck](docs/Model/AllOfHereRequestBodyTruck.md)
 - [AllOfHereRequestBodyVehicleType](docs/Model/AllOfHereRequestBodyVehicleType.md)
 - [AllOfHereResponseSummaryFuelEfficiency](docs/Model/AllOfHereResponseSummaryFuelEfficiency.md)
 - [AllOfHereResponseSummaryVehicleType](docs/Model/AllOfHereResponseSummaryVehicleType.md)
 - [AnyOfbody](docs/Model/AnyOfbody.md)
 - [AsyncResponse](docs/Model/AsyncResponse.md)
 - [Body](docs/Model/Body.md)
 - [Body1](docs/Model/Body1.md)
 - [Cost](docs/Model/Cost.md)
 - [DateTime](docs/Model/DateTime.md)
 - [Direction](docs/Model/Direction.md)
 - [DirectionPosition](docs/Model/DirectionPosition.md)
 - [Driver](docs/Model/Driver.md)
 - [FuelEfficiency](docs/Model/FuelEfficiency.md)
 - [GeoCordinates](docs/Model/GeoCordinates.md)
 - [GmapRequestBody](docs/Model/GmapRequestBody.md)
 - [GmapResponse](docs/Model/GmapResponse.md)
 - [GmapRouteResponse](docs/Model/GmapRouteResponse.md)
 - [HereRequestBody](docs/Model/HereRequestBody.md)
 - [HereResponse](docs/Model/HereResponse.md)
 - [HereResponseSummary](docs/Model/HereResponseSummary.md)
 - [HereResponseSummaryFuelPrice](docs/Model/HereResponseSummaryFuelPrice.md)
 - [HosData](docs/Model/HosData.md)
 - [HosReq](docs/Model/HosReq.md)
 - [HosResponse](docs/Model/HosResponse.md)
 - [HosResponseSummary](docs/Model/HosResponseSummary.md)
 - [HosResponseSummaryTotalDistance](docs/Model/HosResponseSummaryTotalDistance.md)
 - [HosResponseSummaryTotalDriveDuration](docs/Model/HosResponseSummaryTotalDriveDuration.md)
 - [InlineResponse200](docs/Model/InlineResponse200.md)
 - [InlineResponse2001](docs/Model/InlineResponse2001.md)
 - [InlineResponse200Route](docs/Model/InlineResponse200Route.md)
 - [Location](docs/Model/Location.md)
 - [OneOfGmapRequestBodyDepartureTime](docs/Model/OneOfGmapRequestBodyDepartureTime.md)
 - [OneOfHereRequestBodyDepartureTime](docs/Model/OneOfHereRequestBodyDepartureTime.md)
 - [OneOfLocation](docs/Model/OneOfLocation.md)
 - [OneOfinlineResponse2001](docs/Model/OneOfinlineResponse2001.md)
 - [PlaceId](docs/Model/PlaceId.md)
 - [Rates](docs/Model/Rates.md)
 - [Route](docs/Model/Route.md)
 - [RouteLocation](docs/Model/RouteLocation.md)
 - [RouteResponse](docs/Model/RouteResponse.md)
 - [RouteResponseSummary](docs/Model/RouteResponseSummary.md)
 - [RouteResponseSummaryDiffs](docs/Model/RouteResponseSummaryDiffs.md)
 - [RouteResponseSummaryDistance](docs/Model/RouteResponseSummaryDistance.md)
 - [RouteResponseSummaryDuration](docs/Model/RouteResponseSummaryDuration.md)
 - [Stop](docs/Model/Stop.md)
 - [SyncResponse](docs/Model/SyncResponse.md)
 - [SyncResponseRoute](docs/Model/SyncResponseRoute.md)
 - [SyncResponseSummary](docs/Model/SyncResponseSummary.md)
 - [TeritoryMielageRes](docs/Model/TeritoryMielageRes.md)
 - [TeritoryMielageResInner](docs/Model/TeritoryMielageResInner.md)
 - [Timestamp](docs/Model/Timestamp.md)
 - [Toll](docs/Model/Toll.md)
 - [Truck](docs/Model/Truck.md)
 - [VehicleType](docs/Model/VehicleType.md)

## Documentation For Authorization


## authorizer

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

eng@tollguru.com

