# Swagger\Client\OriginAndDestinationPairApi

All URIs are relative to *https://dev.tollguru.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**gmapsPost**](OriginAndDestinationPairApi.md#gmapspost) | **POST** /gmaps | Google Maps Routes
[**herePost**](OriginAndDestinationPairApi.md#herepost) | **POST** /here | HERE Maps Routes

# **gmapsPost**
> \Swagger\Client\Model\GmapResponse gmapsPost($body)

Google Maps Routes

HTTP Request for cars, SUVs, pick-ups, motorcycles

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: authorizer
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('x-api-key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('x-api-key', 'Bearer');

$apiInstance = new Swagger\Client\Api\OriginAndDestinationPairApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \Swagger\Client\Model\GmapRequestBody(); // \Swagger\Client\Model\GmapRequestBody | 

try {
    $result = $apiInstance->gmapsPost($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OriginAndDestinationPairApi->gmapsPost: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\GmapRequestBody**](../Model/GmapRequestBody.md)|  | [optional]

### Return type

[**\Swagger\Client\Model\GmapResponse**](../Model/GmapResponse.md)

### Authorization

[authorizer](../../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **herePost**
> \Swagger\Client\Model\HereResponse herePost($body)

HERE Maps Routes

<p>HTTP Request for trucks, buses, RVs, cars, SUV, pick-ups, motorcycles</p><p>For trucks you should specify truck weight, wherever possible. Some bridges and tunnels restrict trucks based on weight. If you are transporting HAZMAT material, please specify material type. If you do not specify HAZMAT restrictions and weight restrictions, none will be applied.</p>

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: authorizer
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('x-api-key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('x-api-key', 'Bearer');

$apiInstance = new Swagger\Client\Api\OriginAndDestinationPairApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \Swagger\Client\Model\HereRequestBody(); // \Swagger\Client\Model\HereRequestBody | 

try {
    $result = $apiInstance->herePost($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OriginAndDestinationPairApi->herePost: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\HereRequestBody**](../Model/HereRequestBody.md)|  | [optional]

### Return type

[**\Swagger\Client\Model\HereResponse**](../Model/HereResponse.md)

### Authorization

[authorizer](../../README.md#authorizer)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

