<?php
/**
 * HereRequestBody
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * TollGuru Calculator
 *
 * TollGuru Calculator API  # Authentication  <!-- ReDoc-Inject: <security-definitions> -->
 *
 * OpenAPI spec version: 2020-05-31T17:48:12Z
 * Contact: eng@tollguru.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.20
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * HereRequestBody Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class HereRequestBody implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'HereRequestBody';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'from' => 'AllOfHereRequestBodyFrom',
'to' => 'AllOfHereRequestBodyTo',
'waypoints' => '\Swagger\Client\Model\Location[]',
'vehicle_type' => 'AllOfHereRequestBodyVehicleType',
'departure_time' => 'OneOfHereRequestBodyDepartureTime',
'fuel_price' => 'float',
'fuel_price_currency' => 'string',
'fuel_efficiency' => 'AllOfHereRequestBodyFuelEfficiency',
'truck' => 'AllOfHereRequestBodyTruck',
'driver' => 'AllOfHereRequestBodyDriver',
'state_mileage' => 'bool',
'hos' => 'AllOfHereRequestBodyHos'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'from' => null,
'to' => null,
'waypoints' => null,
'vehicle_type' => null,
'departure_time' => null,
'fuel_price' => null,
'fuel_price_currency' => null,
'fuel_efficiency' => null,
'truck' => null,
'driver' => null,
'state_mileage' => null,
'hos' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'from' => 'from',
'to' => 'to',
'waypoints' => 'waypoints',
'vehicle_type' => 'vehicleType',
'departure_time' => 'departure_time',
'fuel_price' => 'fuelPrice',
'fuel_price_currency' => 'fuelPriceCurrency',
'fuel_efficiency' => 'fuelEfficiency',
'truck' => 'truck',
'driver' => 'driver',
'state_mileage' => 'state_mileage',
'hos' => 'hos'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'from' => 'setFrom',
'to' => 'setTo',
'waypoints' => 'setWaypoints',
'vehicle_type' => 'setVehicleType',
'departure_time' => 'setDepartureTime',
'fuel_price' => 'setFuelPrice',
'fuel_price_currency' => 'setFuelPriceCurrency',
'fuel_efficiency' => 'setFuelEfficiency',
'truck' => 'setTruck',
'driver' => 'setDriver',
'state_mileage' => 'setStateMileage',
'hos' => 'setHos'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'from' => 'getFrom',
'to' => 'getTo',
'waypoints' => 'getWaypoints',
'vehicle_type' => 'getVehicleType',
'departure_time' => 'getDepartureTime',
'fuel_price' => 'getFuelPrice',
'fuel_price_currency' => 'getFuelPriceCurrency',
'fuel_efficiency' => 'getFuelEfficiency',
'truck' => 'getTruck',
'driver' => 'getDriver',
'state_mileage' => 'getStateMileage',
'hos' => 'getHos'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const FUEL_PRICE_CURRENCY_USD = 'USD';
const FUEL_PRICE_CURRENCY_CAD = 'CAD';
const FUEL_PRICE_CURRENCY_MXN = 'MXN';
const FUEL_PRICE_CURRENCY_INR = 'INR';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getFuelPriceCurrencyAllowableValues()
    {
        return [
            self::FUEL_PRICE_CURRENCY_USD,
self::FUEL_PRICE_CURRENCY_CAD,
self::FUEL_PRICE_CURRENCY_MXN,
self::FUEL_PRICE_CURRENCY_INR,        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['from'] = isset($data['from']) ? $data['from'] : null;
        $this->container['to'] = isset($data['to']) ? $data['to'] : null;
        $this->container['waypoints'] = isset($data['waypoints']) ? $data['waypoints'] : null;
        $this->container['vehicle_type'] = isset($data['vehicle_type']) ? $data['vehicle_type'] : null;
        $this->container['departure_time'] = isset($data['departure_time']) ? $data['departure_time'] : null;
        $this->container['fuel_price'] = isset($data['fuel_price']) ? $data['fuel_price'] : null;
        $this->container['fuel_price_currency'] = isset($data['fuel_price_currency']) ? $data['fuel_price_currency'] : 'USD';
        $this->container['fuel_efficiency'] = isset($data['fuel_efficiency']) ? $data['fuel_efficiency'] : null;
        $this->container['truck'] = isset($data['truck']) ? $data['truck'] : null;
        $this->container['driver'] = isset($data['driver']) ? $data['driver'] : null;
        $this->container['state_mileage'] = isset($data['state_mileage']) ? $data['state_mileage'] : null;
        $this->container['hos'] = isset($data['hos']) ? $data['hos'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['from'] === null) {
            $invalidProperties[] = "'from' can't be null";
        }
        if ($this->container['to'] === null) {
            $invalidProperties[] = "'to' can't be null";
        }
        $allowedValues = $this->getFuelPriceCurrencyAllowableValues();
        if (!is_null($this->container['fuel_price_currency']) && !in_array($this->container['fuel_price_currency'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value for 'fuel_price_currency', must be one of '%s'",
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets from
     *
     * @return AllOfHereRequestBodyFrom
     */
    public function getFrom()
    {
        return $this->container['from'];
    }

    /**
     * Sets from
     *
     * @param AllOfHereRequestBodyFrom $from from
     *
     * @return $this
     */
    public function setFrom($from)
    {
        $this->container['from'] = $from;

        return $this;
    }

    /**
     * Gets to
     *
     * @return AllOfHereRequestBodyTo
     */
    public function getTo()
    {
        return $this->container['to'];
    }

    /**
     * Sets to
     *
     * @param AllOfHereRequestBodyTo $to to
     *
     * @return $this
     */
    public function setTo($to)
    {
        $this->container['to'] = $to;

        return $this;
    }

    /**
     * Gets waypoints
     *
     * @return \Swagger\Client\Model\Location[]
     */
    public function getWaypoints()
    {
        return $this->container['waypoints'];
    }

    /**
     * Sets waypoints
     *
     * @param \Swagger\Client\Model\Location[] $waypoints waypoints
     *
     * @return $this
     */
    public function setWaypoints($waypoints)
    {
        $this->container['waypoints'] = $waypoints;

        return $this;
    }

    /**
     * Gets vehicle_type
     *
     * @return AllOfHereRequestBodyVehicleType
     */
    public function getVehicleType()
    {
        return $this->container['vehicle_type'];
    }

    /**
     * Sets vehicle_type
     *
     * @param AllOfHereRequestBodyVehicleType $vehicle_type vehicle_type
     *
     * @return $this
     */
    public function setVehicleType($vehicle_type)
    {
        $this->container['vehicle_type'] = $vehicle_type;

        return $this;
    }

    /**
     * Gets departure_time
     *
     * @return OneOfHereRequestBodyDepartureTime
     */
    public function getDepartureTime()
    {
        return $this->container['departure_time'];
    }

    /**
     * Sets departure_time
     *
     * @param OneOfHereRequestBodyDepartureTime $departure_time departure_time
     *
     * @return $this
     */
    public function setDepartureTime($departure_time)
    {
        $this->container['departure_time'] = $departure_time;

        return $this;
    }

    /**
     * Gets fuel_price
     *
     * @return float
     */
    public function getFuelPrice()
    {
        return $this->container['fuel_price'];
    }

    /**
     * Sets fuel_price
     *
     * @param float $fuel_price fuel_price
     *
     * @return $this
     */
    public function setFuelPrice($fuel_price)
    {
        $this->container['fuel_price'] = $fuel_price;

        return $this;
    }

    /**
     * Gets fuel_price_currency
     *
     * @return string
     */
    public function getFuelPriceCurrency()
    {
        return $this->container['fuel_price_currency'];
    }

    /**
     * Sets fuel_price_currency
     *
     * @param string $fuel_price_currency fuel_price_currency
     *
     * @return $this
     */
    public function setFuelPriceCurrency($fuel_price_currency)
    {
        $allowedValues = $this->getFuelPriceCurrencyAllowableValues();
        if (!is_null($fuel_price_currency) && !in_array($fuel_price_currency, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value for 'fuel_price_currency', must be one of '%s'",
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['fuel_price_currency'] = $fuel_price_currency;

        return $this;
    }

    /**
     * Gets fuel_efficiency
     *
     * @return AllOfHereRequestBodyFuelEfficiency
     */
    public function getFuelEfficiency()
    {
        return $this->container['fuel_efficiency'];
    }

    /**
     * Sets fuel_efficiency
     *
     * @param AllOfHereRequestBodyFuelEfficiency $fuel_efficiency fuel_efficiency
     *
     * @return $this
     */
    public function setFuelEfficiency($fuel_efficiency)
    {
        $this->container['fuel_efficiency'] = $fuel_efficiency;

        return $this;
    }

    /**
     * Gets truck
     *
     * @return AllOfHereRequestBodyTruck
     */
    public function getTruck()
    {
        return $this->container['truck'];
    }

    /**
     * Sets truck
     *
     * @param AllOfHereRequestBodyTruck $truck Truck routing only
     *
     * @return $this
     */
    public function setTruck($truck)
    {
        $this->container['truck'] = $truck;

        return $this;
    }

    /**
     * Gets driver
     *
     * @return AllOfHereRequestBodyDriver
     */
    public function getDriver()
    {
        return $this->container['driver'];
    }

    /**
     * Sets driver
     *
     * @param AllOfHereRequestBodyDriver $driver Driver wage or Value of Time
     *
     * @return $this
     */
    public function setDriver($driver)
    {
        $this->container['driver'] = $driver;

        return $this;
    }

    /**
     * Gets state_mileage
     *
     * @return bool
     */
    public function getStateMileage()
    {
        return $this->container['state_mileage'];
    }

    /**
     * Sets state_mileage
     *
     * @param bool $state_mileage state_mileage
     *
     * @return $this
     */
    public function setStateMileage($state_mileage)
    {
        $this->container['state_mileage'] = $state_mileage;

        return $this;
    }

    /**
     * Gets hos
     *
     * @return AllOfHereRequestBodyHos
     */
    public function getHos()
    {
        return $this->container['hos'];
    }

    /**
     * Sets hos
     *
     * @param AllOfHereRequestBodyHos $hos hos
     *
     * @return $this
     */
    public function setHos($hos)
    {
        $this->container['hos'] = $hos;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
